function gsv(fh,g,x,u,h,delta,beta,zeta,theta,grenze_kn,problem);

% Berechnet Loesung mit dem kontrollierten Gauss-
% Seidel-Verfahren auf adaptiven Gittern

% Der Aufbau entspricht zum groessten Teil dem des Programms
% 'iterationsverfahren_mit_spline.m'
% Aus diesem Grund sind nur die neu hinzugekommenen Passagen
% kommentiert.

z_iter=0;                                                 

abbruch=0;

% VORBESETZUNG DER VEKTOREN

ff   = zeros(length(x),length(u));
gg   = zeros(length(x),length(u));
uopt = ones(1,length(x));
v    = zeros(length(x),1);

eta  = 0;

% Durchlaufe Schleife

while(abbruch==0)

zetamax=2*zeta;
z2=0;           % Hilfszaehler

for i=1:length(x)
    for k=1:length(u)
        ff(i,k) = feval(fh,x(i),u(k),h);
        gg(i,k) = feval(g,x(i),u(k));
    end;
end;
        
B=zeros(length(x),length(u),2);      
% In B werden spaeter die Vorfaktoren der linearen Interpolationsformeln
% abgespeichert. Einzelheiten siehe Gruene [11], Kapitel 3.2.
% Zu jedem x_i und jedem u_k sind das im Eindimensionalen 2 Stueck.
% Daher die zwei Matrizen B.

index1=zeros(length(x), length(u));
% Zu jedem x_i und jedem u_k wird in index1 spaeter der Index des Knoten
% links von ff(x_i,u_k) abgespeichert;

index2=zeros(length(x), length(u));
% Zu jedem x_i und jedem u_k wird in index1 spaeter der Index des Knoten
% rechts von ff(x_i,u_k) abgespeichert;

streich=zeros(length(x), length(u));
% In streich(i,:) werden zu jedem x die Indizes k derjenigen u_k
% abgespeichert, fuer die ff(x_i,u_k) nicht in [x_1,x_n] liegt.

  while(zetamax>zeta)                               
    
    v2=v;                     % Vorbelegungen
  
    for i=1:length(x)
    
        z4=1;                   % Hilfszaehler 
        z5=1;                   % Hilfszaehler   
        
        if z2==0
        
        for k=1:length(u)
        
            if ff(i,k)>=x(1) & ff(i,k)<=x(length(x))   
       
               % Bestimmung des Teilintervalls, das ff(x_i,u_k) enthaelt: 
               
               abstand=(x-ff(i,k));             
               min_abstand=min(abs(abstand));
        
               for r=1:length(x)
                   if abs(abstand(r))==min_abstand
                      indexknoten1=r;
                   end
               end
               % Der Index des Eintrags von x, der von ff(x_i,u_k) am 
               % wenigsten weit entfernt liegt, wird gespeichert 
               % in indexknoten1
               
               if abstand(indexknoten1)>0 | indexknoten1==length(x)
                  index1(i,k)= indexknoten1-1;
                  index2(i,k)= indexknoten1;
               else 
                  index1(i,k)=indexknoten1;
                  index2(i,k)=indexknoten1+1;
               end
               % Es wird bestimmt, ob ff(x_i,u_k) links oder rechts von
               % x_indexknoten1 liegt
               
               B(i,z4,1)=(1-(ff(i,k)-x(index1(i,k)))/(x(index2(i,k))-x(index1(i,k))));   
               B(i,z4,2)=(ff(i,k)-x(index1(i,k)))/(x(index2(i,k))-x(index1(i,k)));
               % Berechnung der Interpolationsfaktoren fuer ff(x_i,u_k)
               
               z4=z4+1;
        
            else                                             
               streich(i,z5)=k;                              
               z5=z5+1;
            end
            % Falls ff(x_i,u_k) nicht in [x_i,x_n], so streiche u_k fuer diese Iteration
        end
        end
        
        z6=0;
        
        gg2=gg(i,:);            % Es werden Hilfsvektoren angelegt, damit die zu den
        index12=index1(i,:);    % jeweils "gestrichenen" u_k gehoerigen Werte
        index22=index2(i,:);    % auch gestrichen werden koennen
        
        p=1;                    % Hilfsindex
        
        while(streich(i,p)~=0)
                gg2(streich(i,p)-z6)=[];
                index12(streich(i,p)-z6)=[];
                index22(streich(i,p)-z6)=[];
                z6=z6+1;
                p=p+1;
                if p>length(streich(i,:))
                    break;
                end
        end
        % Die Werte werden gestrichen
          
        for j=1:length(gg2)  
            Bhilf=zeros(1,length(x));
            Bhilf(index12(j))=B(i,j,1);
            Bhilf(index22(j))=B(i,j,2);
            % Zu jedem x_i und u_k werden die zugehoerigen Interpolationsfaktoren
            % in den Vektor Bhilf gespeichert.
            t(j)=(h*gg2(j)+beta.*(Bhilf*v-Bhilf(i)*v(i,1)))/(1-beta.*Bhilf(i));
            % Eine Berechnung des GSV wird durchgefuehrt
        end;
    
        v(i)=max(t);
        
        for j=1:length(t)
            if t(j)==max(t)
                uopt(i)=u(j);
            end
        end
        clear t;     
    end;

    zhilf=1;
    z_iter=z_iter+1;                                               % Zaehler +1
    zeta2=v-v2;
    zetamax=max(abs(zeta2));
    fprintf('\nmax. Schritt: %f    %d    %d',zetamax,length(x),z_iter);
    maxschritt(z_iter)=zetamax;
  end
  
  abbruch=1;

   if problem(1:2)=='wm'                                        
        xhilf3 = x(1):(x(length(x))-x(1))/1000:x(length(x)); 

        z3=1;                                              
           
        for i=1:length(xhilf3)                               
            vhilf3(i)=interp1q(x,v,xhilf3(i));                   
        end
        
        maxfehl(z3)=max(abs(vhilf3-exakt_wm(xhilf3)));       
  
        fprintf('     max. Fehler=    %d',maxfehl(z3));     
        z3=z3+1;
    end
    
% Gitterveraenderung
    
    for i=1:length(x)-1                              
        xx(i)=((x(i+1)+x(i))/2);                                        % zu ueberpruefende Zelle wird halbiert
        vv(i)=interp1q(x,v,xx(i));
    end
    
    for i=1:length(xx)
        for k=1:length(u)
            ff2(i,k) = feval(fh,xx(i),u(k),h);
            gg3(i,k) = feval(g,xx(i),u(k));
        end;
    end;
       
    for i=1:length(xx)
    
    for k=1:length(u)
        t2(k)=(h*gg3(i,k)+beta.*interp1q(x,v,ff2(i,k)));       % Berechnung von T
    end;
    
    vtest2(i)=max(t2);
    clear t2;
    
    end
    
    for i=1:length(xx)
        eta(i)=abs(vtest2(i)-vv(i));
    end

    maxeta=max(eta);
    
    fprintf('      eta: %f    ',maxeta);
    fprintf('      Gesamtfehlerschranke: %f    ',maxeta*(1/(1-beta)));
    
    % neue Knotenpunkte (gespeichert im Vektor xneu):

  if(length(x)<grenze_kn)
    z10=1;
    for i=1:length(xx)
        if eta(i)>theta*maxeta
           xneu(z10)=xx(i);
           vneu(z10)=vv(i);
           z10=z10+1;
        end
    end
    
    xhilf=x;
    vhilf=v;
    
    [x,v]=vektsort(xhilf,vhilf,xneu,vneu); 
   
    clear xneu;
    clear vneu;

    if maxeta>zeta/(1/(1-beta))
        abbruch = 0;
        clear uopt;
    end
  end

end

% Veranschaulicheung der errechneten Ergebnisse

intlaengen=diff(x);                                              
intlaengen(length(x))=intlaengen(length(x)-1);                   

erstelle_graphen_gsv(x, v, uopt, intlaengen, maxschritt);   
